{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}



unit WebForm2;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls, 
  OD.Web.Charting, System.Data.OleDb;

type
  TWebForm2 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure Button1_Click(sender: System.Object; e: System.EventArgs);
    procedure CheckBox1_CheckedChanged(sender: System.Object; e: System.EventArgs);
    procedure Button2_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    OleDbConnection1: System.Data.OleDb.OleDbConnection;
    OleDbCommand1: System.Data.OleDb.OleDbCommand;
    oleDbInsertCommand1: System.Data.OleDb.OleDbCommand;
    oleDbUpdateCommand1: System.Data.OleDb.OleDbCommand;
    oleDbDeleteCommand1: System.Data.OleDb.OleDbCommand;
    OleDbDataAdapter1: System.Data.OleDb.OleDbDataAdapter;
    Button1: System.Web.UI.WebControls.Button;
    Label1: System.Web.UI.WebControls.Label;
    CheckBox1: System.Web.UI.WebControls.CheckBox;
    Button2: System.Web.UI.WebControls.Button;
    WebChart1: OD.Web.Charting.WebChart;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
    function BuildQuery:string;
  public
    { Public Declarations }
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm2.InitializeComponent;
begin
  Self.OleDbConnection1 := System.Data.OleDb.OleDbConnection.Create;
  Self.OleDbCommand1 := System.Data.OleDb.OleDbCommand.Create;
  Self.oleDbInsertCommand1 := System.Data.OleDb.OleDbCommand.Create;
  Self.oleDbUpdateCommand1 := System.Data.OleDb.OleDbCommand.Create;
  Self.oleDbDeleteCommand1 := System.Data.OleDb.OleDbCommand.Create;
  Self.OleDbDataAdapter1 := System.Data.OleDb.OleDbDataAdapter.Create;
  Include(Self.Button1.Click, Self.Button1_Click);
  Include(Self.CheckBox1.CheckedChanged, Self.CheckBox1_CheckedChanged);
  Include(Self.Button2.Click, Self.Button2_Click);
  // 
  // OleDbConnection1
  // 
  Self.OleDbConnection1.ConnectionString := 'Provider="Microsoft.Jet.OLEDB.4' +
  '.0";Data Source="C:\Program Files\Fichiers communs\Borland Shared\Data\db' +
  'demos.mdb";Persist Security Info=False';
  // 
  // OleDbCommand1
  // 
  Self.OleDbCommand1.Connection := Self.OleDbConnection1;
  // 
  // OleDbDataAdapter1
  // 
  Self.OleDbDataAdapter1.DeleteCommand := Self.oleDbDeleteCommand1;
  Self.OleDbDataAdapter1.InsertCommand := Self.oleDbInsertCommand1;
  Self.OleDbDataAdapter1.SelectCommand := Self.OleDbCommand1;
  Self.OleDbDataAdapter1.UpdateCommand := Self.oleDbUpdateCommand1;
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm2.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  // TODO: Put user code to initialize the page here
end;

procedure TWebForm2.OnInit(e: EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;

procedure TWebForm2.Button2_Click(sender: System.Object; e: System.EventArgs);
var table : DataTable;
    max : system.Double;
    cmd : OleDbCommand;
begin
  cmd:= OleDbCommand.Create(
  'SELECT Max(TOTAL) AS MAXTOTAL FROM ('+BuildQuery+')',OleDbConnection1);
  OleDbConnection1.Open;
  max := Convert.ToDouble(cmd.ExecuteScalar);
  OleDbConnection1.Close;
  OleDbCommand1.CommandText := BuildQuery;
  table := DataTable.Create('SALES');
  OleDbDataAdapter1.Fill(table);
  WebChart1.MaxValue := max;
  WebChart1.DataValueFormat := '{0:#,###,### }';
  WebChart1.Title := 'Ventes';
  WebChart1.SubTitle := '(par type de rglement anne: toutes)';
  WebChart1.DataSource := table;
  WebChart1.DataLabelField := 'PaymentMethod';
  WebChart1.DataValueField := 'Total';
  WebChart1.DataBind;
end;

procedure TWebForm2.CheckBox1_CheckedChanged(sender: System.Object; e: System.EventArgs);
begin
  if checkbox1.Checked then
   WebChart1.BackImageURL := 'Nuages2.jpg'
   else WebChart1.BackImageURL := '';
end;

procedure TWebForm2.Button1_Click(sender: System.Object; e: System.EventArgs);
begin
  WebChart1.MaxValue := 11;
  WebChart1.DataValueFormat := '{0} M.hab';
  WebChart1.Title := 'Capitales';
  WebChart1.SubTitle := '(Nom du fleuve en tooltip)';
  WebChart1.Add('Paris',11,'La Seine');
  WebChart1.Add('Rome',3.3,'Le Tibre',Color.DeepSkyBlue);
  WebChart1.Add('Londre',7,'La Tamise',Color.ForestGreen);
  WebChart1.Add('Bangkok',6.3,'Le Chao Phraya',Color.Chartreuse);
end;

function TWebForm2.BuildQuery: string;
begin
 result :=
   'SELECT orders.PaymentMethod, Sum(orders.ItemsTotal) AS Total '+
   'FROM orders '+
   'GROUP BY orders.PaymentMethod';
end;

end.

// Template pour la zone de titre  insrer dans la balise du chart
// dans la page aspx

//  <TitleTemplate>
//	<table width="100%">
//	  <tr>
//		<td><%# "<b>" + Container.WebChart.Title + "</b>&nbsp;" +Container.WebChart.SubTitle %></td>
//		<td align="right"><%# "Scale Factor <b>" + Container.WebChart.MaxValue + "</b>"%></td>
//	  </tr>
//	<table>
//  </TitleTemplate>

