{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}



unit OD.Web.Charting;

interface

uses
  System.Web.UI,
  System.Web.UI.WebControls,
  System.ComponentModel,
  System.Collections,
  System.Drawing;

ResourceString
 // ne pas traduire
 strTitle = 'Title';
 strSubTitle = 'SubTitle';
 strImageURL = 'ImageURL';
 strMaxValue = 'MaxValue';
 strLabelField = 'LabelField';
 strLabelFormat = 'LabelFormat';
 strValueField = 'ValueField';
 strValueFormat = 'ValueFormat';
 strShowBorder = 'ShowBorder';
 strBarColor = 'BarColor';
 strInternalData = 'InternalData';
 // Localisable
 strDefaultTitle = 'Title';
 strDefaultSubTitle = 'Sub Title';


type
   WebChart = Class; // dclaration forward


   [ToolboxItem(false)] // pour ne pas apparatre dans la palette d'outils
   WebChartTemplateContainer = class(System.Web.UI.WebControls.WebControl,INamingContainer)
   strict private
    _parent : WebChart;
   public
    constructor Create(Parent : WebChart);
    property WebChart : WebChart read _parent;
   end;

   [serializable]
   ChartItem = class
     _Text : string;
     _Value : System.Double;
     _ToolTip : string;
     _BackColor : system.drawing.color;
    public
     property Text : string read _Text write _Text;
     property Value : System.Double read _Value write _Value;
     property ToolTip : string read _ToolTip write _ToolTip;
     property BackColor : system.drawing.color read _BackColor write _BackColor;
    end;

   WebChartEventArgs = class (EventArgs)
   public
    IsChartCreated : system.Boolean;
    ChartTable : System.Web.UI.WebControls.Table;
    rowBar : system.Web.UI.WebControls.TableRow;
    Item : ChartItem;
   end;

   WebChartEvent = procedure (sender : system.object; e : WebChartEventArgs) of object;


  [ToolboxData('<{0}:WebChart runat=server></{0}:WebChart>')]
//   ToolboxBitmap('D:\_D2006BOOK\CH39 - ASP.NET Controls\code\charting\OD.Web.WebChart.bmp')]
//  [ToolboxData('<{0}:WebChart runat=server></{0}:WebChart>'),
//   ToolboxBitmap(typeof(WebChart),'OD.Web.WebChart.bmp') ]
  WebChart = class(System.Web.UI.WebControls.WebControl)
  strict private
   _DataSource : system.Object;
   _TitleTemplate : ITemplate;
   _FooterTemplate : ITemplate;
   _Data : ArrayList;
   _TitleTemplateContainer:WebChartTemplateContainer;
   _footerTemplateContainer:WebChartTemplateContainer;
   _OnTableCreated,
   _OnItemCreated : WebChartEvent;
  function ReturnListInterface(dataSource:system.object):IEnumerable;
  strict protected
    function get_InternalData: Arraylist;
    procedure set_InternalData(const Value: Arraylist);
    procedure RenderContents(Output: HtmlTextWriter); override;
    procedure LoadWebChartData; virtual;
    procedure CreateTitleSection(parent:System.Web.UI.WebControls.Table); virtual;
    procedure CreateDefaultTitle(parent:System.Web.UI.WebControls.Table); virtual;
    procedure CreateTemplatedTitle(parent:System.Web.UI.WebControls.Table); virtual;
    procedure CreateWebChart(parent:system.web.ui.webcontrols.tablecell); virtual;
    procedure CreateSingleChart(parent:system.web.ui.webcontrols.tablecell;bci:ChartItem); virtual;
    procedure CreateFooterSection(parent:System.Web.UI.WebControls.Table); virtual;
    property InternalDataSource: Arraylist read get_InternalData write set_InternalData;
    procedure CreateChildControls; override;
    procedure OnDataBinding(e : eventArgs); override;
  public
    // Constructeur
    constructor Create;
    // getters & setters
    function get_Title: string;
    procedure set_Title(const Value: string);
    function get_SubTitle: string;
    procedure set_SubTitle(const Value: string);
    function get_ImageURL: string;
    procedure set_ImageURL(const Value: string);
    function get_MaxValue: System.Double;
    procedure set_MaxValue(const Value: System.Double);
    function get_LabelField: string;
    procedure set_LabelField(const Value: string);
    function get_LabelFormat: string;
    procedure set_LabelFormat(const Value: string);
    function get_ValueField: string;
    function get_ValueFormat: string;
    procedure set_ValueField(const Value: string);
    procedure set_ValueFormat(const Value: string);
    function get_BarColor: System.Drawing.Color;
    function get_ShowBorder: system.boolean;
    procedure set_BarColor(const Value: System.Drawing.Color);
    procedure set_ShowBorder(const Value: system.boolean);
    function get_ItemCount: integer;
    // mthodes surcharges
    procedure DataBind; override;
    // mthodes publiques
    procedure Add(const &Label:string;const Value:System.Double); overload;
    procedure Add(const &Label:string;const Value:System.Double;ToolTip:string); overload;
    procedure Add(const &Label:string;const Value:System.Double;const ToolTip:string;const BarColor:System.Drawing.Color); overload;
    procedure Clear;
    // Proprits publiques non publies
    property ItemCount : integer read get_ItemCount;
  published
    [Category('Titling'),
     DefaultValue(''),
     Description('Titre principal')]
    property Title: string read get_Title write set_Title;
    [Category('Titling'),
     DefaultValue(''),
     Description('Sous titre')]
    property SubTitle: string read get_SubTitle write set_SubTitle;
    [Category('Appearance'),
     DefaultValue(''),
     Description('URL d''une image de fond (optionel)')]
    property BackImageURL: string read get_ImageURL write set_ImageURL;
    [Category('Scaling'),
     DefaultValue(100.0),
     Description('Valeur maximale pouvant tre reprsente')]
    property MaxValue: System.Double read get_MaxValue write set_MaxValue;
    [Category('Data'),
     DefaultValue(0),
     Description('Source de donnes')]
    property DataSource: System.Object read _DataSource write _DataSource;
    [Category('Data'),
     DefaultValue(''),
     Description('Champ retournant le texte de chaque barre')]
    property DataLabelField: string read get_LabelField write set_LabelField;
    [Category('Appearance'),
     DefaultValue(''),
     Description('Chane de format pour le texte des barres')]
    property DataLabelFormat: string read get_LabelFormat write set_LabelFormat;
    [Category('Data'),
     DefaultValue(''),
     Description('Champ retournant la valeur  reprsenter')]
    property DataValueField: string read get_ValueField write set_ValueField;
    [Category('Appearance'),
     DefaultValue(''),
     Description('Format string for the value')]
    property DataValueFormat: string read get_ValueFormat write set_ValueFormat;
    [Category('Titling'),
     TemplateContainer(typeof(WebChartTemplateContainer)),
     Description('Template du titre')]
    property TitleTemplate : ITemplate read _TitleTemplate write _TitleTemplate;
    [Category('Titling'),
     TemplateContainer(typeof(WebChartTemplateContainer)),
     Description('Template pour le pied')]
    property FooterTemplate : ITemplate read _FooterTemplate write _FooterTemplate;
    [Category('Appearance'),
     DefaultValue(false),
     Description('Dessine une bordure autour du graphe')]
    property ShowBorder: system.boolean read get_ShowBorder write set_ShowBorder;
    [Category('Appearance'),
     Description('Couleur des barres. Peut tre chang  la vole')]
    property BarColor: System.Drawing.Color read get_BarColor write set_BarColor;
    // vnements
    [Category('Events'),Description('Dclench quand la table du graphe est cre')]
    property OnTableCreated : WebChartEvent read _OnTableCreated write _OnTableCreated ;
    [Category('Events'),Description('Dclench quand une barre est cre')]
		property OnItemCreated : WebChartEvent  read _OnItemCreated write _OnItemCreated;
  end;

{$R OD.Web.WebChart.bmp }

implementation

{ WebChartTemplateContainer }

constructor WebChartTemplateContainer.Create(Parent: WebChart);
begin
 inherited Create;
 _Parent := Parent;
end;

{ WebChart }

constructor WebChart.Create;
begin
  inherited;
  _Data := ArrayList.Create;
  InternalDataSource := _Data;
  Title := strDefaultTitle;
  SubTitle := strDefaultSubTitle;
  BackImageURL := '';
  MaxValue := 100.0;
  BarColor := Color.BlueViolet;
  ShowBorder := false;
  DataLabelFormat := '{0}';
  DataValueFormat := '{0}';
  Font.Name := 'tahoma';
  Font.Size := FontUnit.Point(8);
  BackColor := Color.White;
  ForeColor := Color.Black;
end;

procedure WebChart.RenderContents(Output: HtmlTextWriter);
var outer: System.Web.UI.WebControls.Table;
    e : WebChartEventArgs;
    ChartRow : system.Web.UI.WebControls.TableRow;
    ChartCell: system.Web.UI.WebControls.TableCell;
begin
 outer := System.Web.UI.WebControls.Table.Create;
 outer.BorderColor := BorderColor;
 outer.BackColor := Color.White;
 outer.BorderStyle := BorderStyle;
 outer.BorderWidth := BorderWidth;
 outer.GridLines := GridLines.None;
 outer.CssClass := CssClass;
 outer.ForeColor := ForeColor;
 outer.Font.Name := Font.Name;
 outer.Font.Size := Font.Size;
 outer.BorderStyle := System.web.UI.WebControls.BorderStyle.Solid;

 CreateTitleSection(outer);

 if assigned(_OnTableCreated) then
  begin
   e:= WebChartEventArgs.Create;
   e.IsChartCreated := false;
   e.ChartTable := outer;
   e.rowBar := nil;
   _OnTableCreated(self,e);
  end;

if assigned(internaldatasource) then
 begin
  ChartRow := TableRow.Create;
  ChartCell:= TableCell.Create;
  CreateWebChart(ChartCell);
  ChartRow.Cells.add(chartcell);
  outer.Rows.Add(ChartRow);
 end;

 CreateFooterSection(outer);

 outer.RenderControl(output);

end;


function WebChart.get_Title: string;
begin
 result := Convert.ToString(ViewState[StrTitle]);
end;


procedure WebChart.set_Title(const Value: string);
begin
 ViewState[StrTitle] := Value;
end;

function WebChart.get_SubTitle: string;
begin
 result := Convert.ToString(ViewState[StrSubTitle]);
end;

procedure WebChart.set_SubTitle(const Value: string);
begin
 ViewState[StrSubTitle] := Value;
end;

function WebChart.get_ImageURL: string;
begin
 result := Convert.ToString(ViewState[StrImageURL]);
end;

procedure WebChart.set_ImageURL(const Value: string);
begin
 ViewState[StrImageURL] := Value;
end;

function WebChart.get_MaxValue: System.Double;
begin
 result := Convert.ToDouble(ViewState[strMaxValue]);
end;

procedure WebChart.set_MaxValue(const Value: System.Double);
begin
 if value<>0.0 then
  ViewState[strMaxValue] := System.Object(Value);
end;


function WebChart.get_LabelField: string;
begin
 result := Convert.ToString(ViewState[strlabelField]);
end;

procedure WebChart.set_LabelField(const Value: string);
begin
 ViewState[strlabelField] := Value;
end;

function WebChart.get_LabelFormat: string;
begin
 result := Convert.ToString(ViewState[strLabelFormat]);
end;

procedure WebChart.set_LabelFormat(const Value: string);
begin
 ViewState[strLabelFormat] := Value;
end;

function WebChart.get_ValueField: string;
begin
 result := Convert.ToString(ViewState[strValueField]);
end;

procedure WebChart.set_ValueField(const Value: string);
begin
 ViewState[strValueField] := Value;
end;

function WebChart.get_ValueFormat: string;
begin
 result := Convert.ToString(ViewState[strValueFormat]);
end;

procedure WebChart.set_ValueFormat(const Value: string);
begin
 ViewState[strValueFormat] := Value;
end;


procedure WebChart.DataBind;
begin
  inherited;
  LoadWebChartData;
end;

procedure WebChart.LoadWebChartData;
var data : IEnumerable; e:IEnumerator;
    dataItem : system.object;
    TheLabel : string;
    TheValue : System.Double;
begin
 data := ReturnListInterface(DataSource);
 if data=nil then exit;
 e := Data.GetEnumerator;
 While e.MoveNext do
  begin
   dataitem := e.Current;
   TheLabel := system.String(DataBinder.Eval(dataItem,DataLabelField));
   TheValue := Convert.ToSingle(DataBinder.Eval(dataItem, DataValueField));
   Add(theLabel, theValue);
  end;
end;

procedure WebChart.Add(const &Label: string; const Value: System.Double;
  const ToolTip: string; const BarColor: System.Drawing.Color);
var ci : ChartItem;
begin
 ci := ChartItem.Create;
 ci.Text := &Label;
 ci.Value := Value;
 ci.ToolTip := ToolTip;
 ci.BackColor := BarColor;
 if assigned(_Data) then _Data.Add(ci);
 InternalDataSource := _Data;
end;


procedure WebChart.Add(const &Label: string; const Value: System.Double;
  ToolTip: string);
begin
 Add(&Label,Value,ToolTip,BarColor);
end;

procedure WebChart.Add(const &Label: string; const Value: System.Double);
begin
 Add(&Label,Value,'',BarColor);
end;

function WebChart.get_ShowBorder: system.boolean;
begin
result := Convert.ToBoolean(ViewState[strShowBorder]);
end;

procedure WebChart.set_ShowBorder(const Value: system.boolean);
begin
 ViewState[strShowBorder] := system.Object(Value);
end;

function WebChart.get_BarColor: System.Drawing.Color;
begin
 result := System.Drawing.Color(ViewState[StrBarColor]);
end;

procedure WebChart.set_BarColor(const Value: System.Drawing.Color);
begin
 ViewState[strBarColor] := Value;
end;


function WebChart.get_InternalData: Arraylist;
begin
 result := ArrayList(ViewState[strInternalData]);
end;

procedure WebChart.set_InternalData(const Value: Arraylist);
begin
 ViewState[strInternalData] := Value;
end;

function WebChart.get_ItemCount: integer;
begin
 if assigned(InternalDataSource) then
  result := InternalDataSource.Count else result := 0;
end;

procedure WebChart.CreateTitleSection(parent: System.Web.UI.WebControls.Table);
begin
 if assigned(TitleTemplate) then CreateTemplatedTitle(parent)
                            else CreateDefaultTitle(parent);
end;

procedure WebChart.CreateDefaultTitle(parent: System.Web.UI.WebControls.Table);
var TitleRow,SubTitleRow : System.Web.UI.WebControls.TableRow;
    TitleCell,SubTitleCell: System.Web.UI.WebControls.TableCell;
begin
 TitleRow := TableRow.Create;
 if not Title.Equals(System.&String.Empty) then
  begin
  	TitleCell := TableCell.Create;
		TitleCell.ColumnSpan := ItemCount;
		TitleCell.HorizontalAlign := HorizontalAlign.Center;
		TitleCell.Font.Bold := true;
		TitleCell.Font.Size := FontUnit.Larger;
		TitleCell.Text := Title;
		TitleRow.Cells.Add(TitleCell);
  end;
 parent.Rows.Add(TitleRow);
 SubTitleRow := TableRow.Create;
 if not SubTitle.Equals(System.&String.Empty) then
  begin
  	SubTitleCell := TableCell.Create;
		SubTitleCell.ColumnSpan := ItemCount;
		SubTitleCell.HorizontalAlign := HorizontalAlign.Center;
		SubTitleCell.Font.Size := FontUnit.Smaller;
		SubTitleCell.Text := SubTitle;
		SubTitleRow.Cells.Add(SubTitleCell);
  end;
 parent.Rows.Add(SubTitleRow);
end;

procedure WebChart.CreateTemplatedTitle(
  parent: System.Web.UI.WebControls.Table);
 var TitleRow : System.Web.UI.WebControls.TableRow;
     TitleCell: System.Web.UI.WebControls.TableCell;
begin
 TitleRow := TableRow.Create;
 TitleCell := TableCell.Create;
 TitleCell.ColumnSpan := ItemCount;
 if assigned(TitleTemplate) then TitleCell.Controls.add(_titleTemplateContainer);
 TitleRow.Cells.Add(TitleCell);
 parent.Rows.Add(TitleRow);
end;


procedure WebChart.CreateWebChart(parent: system.web.ui.webcontrols.tablecell);
var chart: system.Web.UI.WebControls.Table;
    rowchart,rowseparator,rowfooter : system.web.UI.WebControls.TableRow;
    bci : ChartItem;
    barcell,separatorCell,footercell : system.Web.UI.WebControls.TableCell;
begin
 chart := table.Create;
 Chart.ForeColor := ForeColor;
 Chart.CssClass := CssClass;
 Chart.GridLines := Gridlines.None;
 if ShowBorder then
  begin
   Chart.BorderStyle := System.Web.Ui.WebControls.BorderStyle.Solid;
   Chart.BorderColor := Color.Black;
   Chart.BorderWidth := &Unit.Pixel(1);
  end;
 Chart.BackColor := BackColor;
 Chart.Font.Name := Font.Name;
 Chart.Font.Size := Font.Size;
 Chart.CellSpacing := 0;
 Chart.CellPadding := 2;
 Chart.BackImageUrl := BackImageURL;
 Chart.Style['background-position'] := 'bottom';
 Chart.Width := width;
 chart.Height := height;

 rowChart := TableRow.Create;
 rowChart.VerticalAlign := VerticalAlign.Bottom;

 for bci in InternalDataSource do
  begin
   barcell := TableCell.Create;
   CreateSingleChart(barCell,bci);
   rowChart.Cells.add(barcell);
  end;

 if InternalDataSource.Count = 0 then rowchart.Cells.Add(TableCell.Create);

 Chart.Rows.Add(rowChart);

 rowseparator := TableRow.Create;
 rowSeparator.VerticalAlign := VerticalAlign.Bottom;
 rowSeparator.Height := 2;
 separatorCell := TableCell.Create;
 separatorCell.BackColor := Color.Black;
 separatorCell.ColumnSpan := ItemCount;
 rowSeparator.Cells.Add(separatorCell);
 chart.Rows.Add(rowSeparator);

 rowfooter := TableRow.Create;
 rowFooter.Height := 10;
 rowFooter.VerticalAlign := VerticalAlign.Bottom;
 rowFooter.BackColor := Color.LightYellow;

 for bci in InternalDataSource do
  begin
   footerCell := TableCell.Create;
   footerCell.HorizontalAlign := HorizontalAlign.Center;
   footerCell.Text := System.String.Format(DataLabelFormat, bci.Text);
   rowFooter.Cells.Add(footerCell);
  end;

 if (InternalDataSource.Count = 0) then
  		rowFooter.Cells.Add(TableCell.Create);

 chart.Rows.Add(rowFooter);

 parent.Controls.Add(chart);
end;

procedure WebChart.CreateSingleChart(
  parent: system.web.ui.webcontrols.tablecell; bci: ChartItem);
var ValueToRepresent : system.Double;
    t : system.web.ui.webcontrols.Table;
    todoarea,valuearea,barArea: system.web.ui.webcontrols.TableRow;
    cell : system.web.ui.webcontrols.tablecell;
    e : WebChartEventArgs;
begin
 ValueToRepresent := 100.0*(bci.Value/MaxValue);
 t := table.create;
 t.Font.Name := Font.Name;
 t.Font.Size := Font.Size;
 t.Width := &Unit.Percentage(100);
 t.Height := &Unit.Percentage(100);

 todoarea := tableRow.Create;
 todoArea.Height := &Unit.Percentage(100.0-valueToRepresent);
 todoArea.Cells.Add(TableCell.Create);
 t.Rows.Add(todoArea);

 valuearea := tablerow.create;
 valueArea.Height := 10;
 cell := TableCell.Create;
 cell.HorizontalAlign := HorizontalAlign.Center;
 cell.Text := System.String.Format(DataValueFormat, system.object(bci.Value));
 valueArea.Cells.Add(cell);
 t.Rows.Add(valueArea);

 barArea := tablerow.create;
 barArea.ToolTip := bci.ToolTip;
 barArea.Height := &Unit.Percentage(valueToRepresent);
 barArea.BackColor := bci.BackColor;
 barArea.Cells.Add(TableCell.Create);
 t.Rows.Add(barArea);

 if assigned(_OnItemCreated) then
  begin
    e := WebChartEventArgs.Create;
    e.IsChartCreated := true;
    e.ChartTable := nil;
    e.rowBar := barArea;
    e.Item := bci;
    _OnItemCreated(Self, e);
    bci := e.Item;
  end;


  parent.Controls.Add(t);
end;

procedure WebChart.CreateFooterSection(parent: System.Web.UI.WebControls.Table);
var rowinfo : system.web.ui.WebControls.TableRow;
    infoCell : system.web.ui.Webcontrols.TableCell;
begin
 if assigned(FooterTemplate) then
  begin
   rowinfo := tableRow.create;
   rowInfo.VerticalAlign := VerticalAlign.Bottom;
   infocell := tablecell.create;
   infoCell.Font.Name := parent.Font.Name;
   infoCell.Font.Size := FontUnit.Smaller;
   infoCell.ColumnSpan := ItemCount;
   infoCell.Controls.Add(_footerTemplateContainer);
   rowInfo.Cells.Add(infoCell);
   parent.Rows.Add(rowInfo);
  end;
end;

function WebChart.ReturnListInterface(dataSource: TObject): IEnumerable;
var listSource : IListSource;
    list : IList;
begin
 result := nil;
 if datasource=nil then exit; 
 listSource := (dataSource as IListSource);
 if assigned(listsource) then
  begin
   list := listsource.GetList;
   if not listsource.ContainsListCollection then
    begin result := list; exit; end;
  end;
 if (datasource as IEnumerable)<>nil then
  begin result := (datasource as IEnumerable); exit; end;
end;

procedure WebChart.CreateChildControls;
begin
  inherited;
  if assigned(TitleTemplate) then
      begin
        _TitleTemplateContainer := WebChartTemplateContainer.Create(self);
        TitleTemplate.InstantiateIn(_TitleTemplateContainer);
        Controls.Add(_TitleTemplateContainer);
      end;

      if assigned(FooterTemplate) then
      begin
        _footerTemplateContainer := WebChartTemplateContainer.Create(self);
        FooterTemplate.InstantiateIn(_footerTemplateContainer);
        Controls.Add(_footerTemplateContainer);
      end;
end;

procedure WebChart.OnDataBinding(e: eventArgs);
begin
  inherited;
  EnsureChildControls;
end;

procedure WebChart.Clear;
begin
 _Data.Clear;
end;

end.
